blob: 6b8f00748bc5b36ee39db7089af52227da7cc931 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
40 tmp_dir="${TMPDIR}/$USER/${test_dir}"
41fi
jeffhao5d1ac922011-09-29 17:41:15 -070042
43export JAVA="java"
Brian Carlstrom5103ce62014-03-30 16:17:42 -070044export JAVAC="javac -g"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
jeffhao5d1ac922011-09-29 17:41:15 -070048
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070049# If dx was not set by the environment variable, assume it is in the path.
50if [ -z "$DX" ]; then
51 export DX="dx"
52fi
53
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080054# If jasmin was not set by the environment variable, assume it is in the path.
55if [ -z "$JASMIN" ]; then
56 export JASMIN="jasmin"
57fi
58
Andreas Gampe8fda9f22014-10-03 16:15:37 -070059# If smali was not set by the environment variable, assume it is in the path.
60if [ -z "$SMALI" ]; then
61 export SMALI="smali"
62fi
63
64# If dexmerger was not set by the environment variable, assume it is in the path.
65if [ -z "$DXMERGER" ]; then
66 export DXMERGER="dexmerger"
67fi
68
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080069
jeffhao5d1ac922011-09-29 17:41:15 -070070info="info.txt"
71build="build"
72run="run"
73expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070074check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070075output="output.txt"
76build_output="build-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -070077lib="libartd.so"
jeffhao5d1ac922011-09-29 17:41:15 -070078run_args="--quiet"
79
Alex Light9d722532014-07-22 18:07:12 -070080prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -070081target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -070082dev_mode="no"
83update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -070084debug_mode="no"
85relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -080086runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -070087usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -070088build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -070089suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -070090trace="false"
Alex Lighte7873ec2014-08-12 09:53:50 -070091basic_verify="false"
92gc_verify="false"
93gc_stress="false"
Alex Lightbfac14a2014-07-30 09:41:21 -070094always_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -070095have_dex2oat="yes"
96have_patchoat="yes"
97have_image="yes"
Andreas Gampe63fc30e2014-10-24 21:58:16 -070098image_suffix=""
Andreas Gampec23c9c92014-10-28 14:47:25 -070099pic_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000100android_root="/system"
jeffhao5d1ac922011-09-29 17:41:15 -0700101
102while true; do
103 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700104 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700105 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100106 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700107 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800108 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700109 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800110 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700111 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700112 NEED_DEX="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100113 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700114 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800115 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700116 lib="libart.so"
117 shift
118 elif [ "x$1" = "x--dalvik" ]; then
119 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800120 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700121 shift
Alex Light03a112d2014-08-25 13:25:56 -0700122 elif [ "x$1" = "x--no-dex2oat" ]; then
123 have_dex2oat="no"
124 shift
125 elif [ "x$1" = "x--no-patchoat" ]; then
126 have_patchoat="no"
127 shift
128 elif [ "x$1" = "x--no-image" ]; then
129 have_image="no"
130 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700131 elif [ "x$1" = "x--pic-image" ]; then
132 pic_image_suffix="-pic"
133 shift
134 elif [ "x$1" = "x--pic-test" ]; then
135 run_args="${run_args} --pic-test"
136 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700137 elif [ "x$1" = "x--relocate" ]; then
138 relocate="yes"
139 shift
140 elif [ "x$1" = "x--no-relocate" ]; then
141 relocate="no"
142 shift
143 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100144 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700145 prebuild_mode="yes"
146 shift;
147 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100148 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700149 prebuild_mode="no"
150 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700151 elif [ "x$1" = "x--gcverify" ]; then
152 basic_verify="true"
153 gc_verify="true"
154 shift
155 elif [ "x$1" = "x--gcstress" ]; then
156 basic_verify="true"
157 gc_stress="true"
158 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700159 elif [ "x$1" = "x--image" ]; then
160 shift
161 image="$1"
162 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700163 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000164 elif [ "x$1" = "x-Xcompiler-option" ]; then
165 shift
166 option="$1"
167 run_args="${run_args} -Xcompiler-option $option"
168 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700169 elif [ "x$1" = "x--runtime-option" ]; then
170 shift
171 option="$1"
172 run_args="${run_args} --runtime-option $option"
173 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700174 elif [ "x$1" = "x--gdb-arg" ]; then
175 shift
176 gdb_arg="$1"
177 run_args="${run_args} --gdb-arg $gdb_arg"
178 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700179 elif [ "x$1" = "x--debug" ]; then
180 run_args="${run_args} --debug"
181 shift
182 elif [ "x$1" = "x--gdb" ]; then
183 run_args="${run_args} --gdb"
184 dev_mode="yes"
185 shift
186 elif [ "x$1" = "x--zygote" ]; then
187 run_args="${run_args} --zygote"
188 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800189 elif [ "x$1" = "x--interpreter" ]; then
190 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700191 image_suffix="-interpreter"
192 shift
193 elif [ "x$1" = "x--optimizing" ]; then
194 run_args="${run_args} -Xcompiler-option --compiler-backend=Optimizing"
195 image_suffix="-optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800196 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700197 elif [ "x$1" = "x--no-verify" ]; then
198 run_args="${run_args} --no-verify"
199 shift
200 elif [ "x$1" = "x--no-optimize" ]; then
201 run_args="${run_args} --no-optimize"
202 shift
203 elif [ "x$1" = "x--no-precise" ]; then
204 run_args="${run_args} --no-precise"
205 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700206 elif [ "x$1" = "x--invoke-with" ]; then
207 shift
208 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700209 if [ "x$what" = "x" ]; then
210 echo "$0 missing argument to --invoke-with" 1>&2
211 usage="yes"
212 break
213 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700214 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700215 shift
216 elif [ "x$1" = "x--dev" ]; then
217 run_args="${run_args} --dev"
218 dev_mode="yes"
219 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700220 elif [ "x$1" = "x--build-only" ]; then
221 build_only="yes"
222 shift
223 elif [ "x$1" = "x--output-path" ]; then
224 shift
225 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700226 if [ "x$tmp_dir" = "x" ]; then
227 echo "$0 missing argument to --output-path" 1>&2
228 usage="yes"
229 break
230 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700231 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000232 elif [ "x$1" = "x--android-root" ]; then
233 shift
234 if [ "x$1" = "x" ]; then
235 echo "$0 missing argument to --android-root" 1>&2
236 usage="yes"
237 break
238 fi
239 android_root="$1"
240 run_args="${run_args} --android-root $1"
241 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700242 elif [ "x$1" = "x--update" ]; then
243 update_mode="yes"
244 shift
245 elif [ "x$1" = "x--help" ]; then
246 usage="yes"
247 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700248 elif [ "x$1" = "x--64" ]; then
249 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700250 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700251 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200252 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700253 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200254 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700255 elif [ "x$1" = "x--always-clean" ]; then
256 always_clean="yes"
257 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700258 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700259 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700260 usage="yes"
261 break
262 else
263 break
264 fi
265done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700266
267# tmp_dir may be relative, resolve.
268#
269# Cannot use realpath, as it does not exist on Mac.
270# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700271# Cannot use readlink -m, as it does not exist on Mac.
272# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700273noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700274tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700275mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700276
Alex Lighte7873ec2014-08-12 09:53:50 -0700277if [ "$basic_verify" = "true" ]; then
278 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify"
279fi
280if [ "$gc_verify" = "true" ]; then
281 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
282fi
283if [ "$gc_stress" = "true" ]; then
284 run_args="${run_args} --runtime-option -Xgc:SS --runtime-option -Xms2m --runtime-option -Xmx2m"
285fi
Jeff Hao85139a32014-07-23 11:52:52 -0700286if [ "$trace" = "true" ]; then
287 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin --runtime-option -Xmethod-trace-file-size:2000000"
288fi
289
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700290# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100291# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700292function guess_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100293 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
294 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700295 if [ "x${suffix64}" = "x64" ]; then
296 target_arch_name=${grep64bit}
297 else
298 target_arch_name=${grep32bit}
299 fi
300}
301
Alex Lighta59dd802014-07-02 16:28:08 -0700302if [ "$target_mode" = "no" ]; then
303 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700304 if [ "$prebuild_mode" = "yes" ]; then
305 echo "--prebuild with --jvm is unsupported";
306 exit 1;
307 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700308 fi
309fi
310
Alex Light03a112d2014-08-25 13:25:56 -0700311if [ "$have_patchoat" = "no" ]; then
312 run_args="${run_args} --no-patchoat"
313fi
314
315if [ "$have_dex2oat" = "no" ]; then
316 run_args="${run_args} --no-dex2oat"
317fi
318
Jeff Hao201803f2013-11-20 18:11:39 -0800319if [ ! "$runtime" = "jvm" ]; then
320 run_args="${run_args} --lib $lib"
321fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700322
Jeff Hao201803f2013-11-20 18:11:39 -0800323if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700324 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100325 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700326 bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
327 run_args="${run_args} --boot -Xbootclasspath:${bpath}"
328 else
329 true # defaults to using target BOOTCLASSPATH
330 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800331elif [ "$runtime" = "art" ]; then
332 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100333 # ANDROID_BUILD_TOP and ANDROID_HOST_OUT are not set in a build environment.
Brian Carlstrom43534862014-02-19 01:13:52 -0800334 if [ -z "$ANDROID_BUILD_TOP" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100335 export ANDROID_BUILD_TOP=$oldwd
Brian Carlstrom43534862014-02-19 01:13:52 -0800336 fi
337 if [ -z "$ANDROID_HOST_OUT" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100338 export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86
Brian Carlstrom43534862014-02-19 01:13:52 -0800339 fi
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000340 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}.art"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700341 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800342 else
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700343 guess_arch_name
344 run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000345 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800346 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700347 if [ "$relocate" = "yes" ]; then
348 run_args="${run_args} --relocate"
349 else
350 run_args="${run_args} --no-relocate"
351 fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700352fi
353
Alex Light03a112d2014-08-25 13:25:56 -0700354if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700355 if [ "$runtime" != "art" ]; then
356 echo "--no-image is only supported on the art runtime"
357 exit 1
358 fi
359 if [ "$target_mode" = "no" ]; then
360 framework="${ANDROID_HOST_OUT}/framework"
361 bpath_suffix="-hostdex"
362 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000363 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700364 bpath_suffix=""
365 fi
366 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
367 # fail since these jar files will be stripped.
368 bpath="${framework}/core-libart${bpath_suffix}.jar"
369 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
370 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
371 bpath="${bpath}:${framework}/core-junit${bpath_suffix}.jar"
372 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
373 # Pass down the bootclasspath
374 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700375 run_args="${run_args} --no-image"
376fi
377
jeffhao5d1ac922011-09-29 17:41:15 -0700378if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
379 echo "--dev and --update are mutually exclusive" 1>&2
380 usage="yes"
381fi
382
383if [ "$usage" = "no" ]; then
384 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
385 test_dir=`basename "$oldwd"`
386 else
387 test_dir="$1"
388 fi
389
390 if [ '!' -d "$test_dir" ]; then
391 td2=`echo ${test_dir}-*`
392 if [ '!' -d "$td2" ]; then
393 echo "${test_dir}: no such test directory" 1>&2
394 usage="yes"
395 fi
396 test_dir="$td2"
397 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700398 # Shift to get rid of the test name argument. The rest of the arguments
399 # will get passed to the test run.
400 shift
401fi
402
403if [ "$usage" = "yes" ]; then
404 prog=`basename $prog`
405 (
406 echo "usage:"
407 echo " $prog --help Print this message."
408 echo " $prog [options] [test-name] Run test normally."
409 echo " $prog --dev [options] [test-name] Development mode" \
410 "(dumps to stdout)."
411 echo " $prog --update [options] [test-name] Update mode" \
412 "(replaces expected.txt)."
413 echo ' Omitting the test name or specifying "-" will use the' \
414 "current directory."
415 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000416 echo " -O Run non-debug rather than debug build (off by default)."
417 echo " -Xcompiler-option Pass an option to the compiler."
418 echo " --runtime-option Pass an option to the runtime."
419 echo " --debug Wait for a debugger to attach."
420 echo " --gdb Run under gdb; incompatible with some tests."
421 echo " --build-only Build test files only (off by default)."
422 echo " --interpreter Enable interpreter only mode (off by default)."
423 echo " --optimizing Enable optimizing compiler (off by default)."
424 echo " --no-verify Turn off verification (on by default)."
425 echo " --no-optimize Turn off optimization (on by default)."
426 echo " --no-precise Turn off precise GC (on by default)."
427 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700428 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000429 echo " other runtime options are ignored."
430 echo " --no-dex2oat Run as though dex2oat was failing."
431 echo " --no-patchoat Run as though patchoat was failing."
432 echo " --prebuild Run dex2oat on the files before starting test. (default)"
433 echo " --no-prebuild Do not run dex2oat on the files before starting"
434 echo " the test."
435 echo " --relocate Force the use of relocating in the test, making"
436 echo " the image and oat files be relocated to a random"
437 echo " address before running. (default)"
438 echo " --no-relocate Force the use of no relocating in the test"
439 echo " --host Use the host-mode virtual machine."
440 echo " --invoke-with Pass --invoke-with option to runtime."
441 echo " --dalvik Use Dalvik (off by default)."
442 echo " --jvm Use a host-local RI virtual machine."
443 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700444 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000445 echo " --64 Run the test in 64-bit mode"
446 echo " --trace Run with method tracing"
447 echo " --gcstress Run with gc stress testing"
448 echo " --gcverify Run with gc verification"
449 echo " --always-clean Delete the test files even if the test fails."
450 echo " --android-root [path] The path on target for the android root. (/system by default)."
jeffhao5d1ac922011-09-29 17:41:15 -0700451 ) 1>&2
452 exit 1
453fi
454
455cd "$test_dir"
456test_dir=`pwd`
457
458td_info="${test_dir}/${info}"
459td_expected="${test_dir}/${expected}"
460
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700461if [ ! -r $td_info ]; then
462 echo "${test_dir}: missing file $td_info" 1>&2
463 exit 1
464fi
465
466if [ ! -r $td_expected ]; then
467 echo "${test_dir}: missing file $td_expected" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700468 exit 1
469fi
470
471# copy the test to a temp dir and run it
472
Elliott Hughes510c8782011-10-06 10:57:34 -0700473echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700474
475rm -rf "$tmp_dir"
476cp -Rp "$test_dir" "$tmp_dir"
477cd "$tmp_dir"
478
479if [ '!' -r "$build" ]; then
480 cp "${progdir}/etc/default-build" build
481fi
482
483if [ '!' -r "$run" ]; then
484 cp "${progdir}/etc/default-run" run
485fi
486
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700487if [ '!' -r "$check_cmd" ]; then
488 cp "${progdir}/etc/default-check" check
489fi
490
jeffhao5d1ac922011-09-29 17:41:15 -0700491chmod 755 "$build"
492chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700493chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700494
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700495export TEST_NAME=`basename ${test_dir}`
496
Ian Rogers997f0f92014-06-21 22:58:05 -0700497# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
498file_size_limit=2048
499if echo "$test_dir" | grep 089; then
500 file_size_limit=5120
501elif echo "$test_dir" | grep 083; then
502 file_size_limit=5120
503fi
Alex Lighta59dd802014-07-02 16:28:08 -0700504if ! ulimit -S "$file_size_limit"; then
Ian Rogers997f0f92014-06-21 22:58:05 -0700505 echo "ulimit file size setting failed"
506fi
507
jeffhao5d1ac922011-09-29 17:41:15 -0700508good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000509good_build="yes"
510good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700511if [ "$dev_mode" = "yes" ]; then
512 "./${build}" 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700513 build_exit="$?"
514 echo "build exit status: $build_exit" 1>&2
515 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800516 echo "${test_dir}: running..." 1>&2
517 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700518 run_exit="$?"
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800519 echo "run exit status: $run_exit" 1>&2
520 if [ "$run_exit" = "0" ]; then
521 good="yes"
522 fi
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700523 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700524elif [ "$update_mode" = "yes" ]; then
525 "./${build}" >"$build_output" 2>&1
526 build_exit="$?"
527 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800528 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700529 "./${run}" $run_args "$@" >"$output" 2>&1
530 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
531 good="yes"
532 else
533 cat "$build_output" 1>&2
534 echo "build exit status: $build_exit" 1>&2
535 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700536elif [ "$build_only" = "yes" ]; then
537 good="yes"
538 "./${build}" >"$build_output" 2>&1
539 build_exit="$?"
540 if [ "$build_exit" '!=' '0' ]; then
541 cp "$build_output" "$output"
542 echo "build exit status: $build_exit" >>"$output"
543 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
544 if [ "$?" '!=' "0" ]; then
545 good="no"
546 echo "BUILD FAILED For ${TEST_NAME}"
547 fi
548 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700549 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700550 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700551 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700552else
553 "./${build}" >"$build_output" 2>&1
554 build_exit="$?"
555 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800556 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700557 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000558 run_exit="$?"
559 if [ "$run_exit" != "0" ]; then
560 echo "run exit status: $run_exit" 1>&2
561 good_run="no"
562 else
563 good_run="yes"
564 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700565 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000566 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700567 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700568 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
569 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700570 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700571 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700572 max_name_length=$(getconf NAME_MAX ${tmp_dir})
573 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
574 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700575 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700576 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700577 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700578 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000579 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
580 # output == expected
581 good="yes"
582 echo "${test_dir}: succeeded!" 1>&2
583 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700584 fi
585fi
586
jeffhao5d1ac922011-09-29 17:41:15 -0700587(
Alex Lightbfac14a2014-07-30 09:41:21 -0700588 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700589 echo "${test_dir}: FAILED!"
590 echo ' '
591 echo '#################### info'
592 cat "${td_info}" | sed 's/^/# /g'
593 echo '#################### diffs'
Ian Rogers75deec02014-11-23 20:07:39 -0800594 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 2000
jeffhao5d1ac922011-09-29 17:41:15 -0700595 echo '####################'
596 echo ' '
597 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700598
599) 1>&2
600
601# Clean up test files.
602if [ "$always_clean" = "yes" -o "$good" = "yes" ]; then
603 cd "$oldwd"
604 rm -rf "$tmp_dir"
605 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
606 adb shell rm -rf $DEX_LOCATION
607 fi
608 if [ "$good" = "yes" ]; then
609 exit 0
610 fi
611fi
612
613
614(
615 if [ "$always_clean" = "yes" ]; then
616 echo "${TEST_NAME} files deleted from host "
617 if [ "$target_mode" == "yes" ]; then
618 echo "and from target"
619 fi
620 else
621 echo "${TEST_NAME} files left in ${tmp_dir} on host"
622 if [ "$target_mode" == "yes" ]; then
623 echo "and in ${DEX_LOCATION} on target"
624 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700625 fi
626
jeffhao5d1ac922011-09-29 17:41:15 -0700627) 1>&2
628
629exit 1